<template lang="pug">  
  div
    BulmaAccordion
    .hero-body.has-background-dark.has-text-light
      .container.has-text-centered
        nav.level
          .level-left
            .level-item
              .field
                input.switch.is-small(id="milonga", type="checkbox", name="milonga", checked="checked", v-model="filtros.milonga")
                label(for="milonga") Milongas
            .level-item
              .field
                input.switch.is-small(id="practica", type="checkbox", name="practica", checked="checked", v-model="filtros.practica")
                label(for="practica") Practicas
            .level-item
              .field
                input.switch.is-small(id="eventos", type="checkbox", name="eventos", checked="checked", v-model="filtros.eventos")
                label(for="eventos") Eventos
          .level-right
            
    gmap-map(:center="center",:zoom="3",style="width:100%;  height: 700px;")    
      gmap-marker(:key="index",v-for="(m, index) in todosLosSitios",:position="m.position",:icon="m.icon",@click="center=m.position")
</template>

<script>
import mapsManagerService from '../services/mapsManager.service.js'
import { tangoSitiosRef, tangoEventosRef } from '../firebase.js'
import { uuid } from 'vue-uuid';
import { BulmaAccordion, BulmaAccordionItem } from 'vue-bulma-accordion'

export default {
  name: "GoogleMap",
  data() {
    return {
      // default to Montreal to keep it simple
      // change this to whatever makes sense
      center: { lat: 45.508, lng: -73.587 },
      markers: [],
      filtros: {
        milonga: true,
        practica: true,
        eventos: false
      },
      places: [],
      icons: {'once a week': require('@/assets/Icons/RedIcon_40.png'),
							'once a month': require('@/assets/Icons/BlueGreenIcon_40.png'),
							'twice a month': require('@/assets/Icons/PurpleIcon_40.png'),
							'event': require('@/assets/Icons/eventIcon_40.png')},
      currentPlace: null
    };
  },
    components: {
        BulmaAccordion,
        BulmaAccordionItem
    },

  mounted() {
    this.geolocate();
    this.getAll();
    this.addMarker();
  },
  computed: {
    todosLosSitios() {
      let puntos = []
      _.each(this.sites, (site) => {    
        if ((this.filtros.milonga && site.business === 'milonga') ||
            (this.filtros.milonga && site.business === 'practicas')) {    
          puntos.push({          
            position: {
              lat: site.coordinates.lat,
              lng: site.coordinates.lng
            },
            icon: this.icons[site.icon]
          });  
        }
      })
      
      if (this.filtros.eventos) {
        _.each(this.events, (event) => {
          puntos.push({          
            position: {
              lat: event.coordinates.lat,
              lng: event.coordinates.lng
            },
            icon: this.icons[event.icon]
          });  
        })
      }
      return puntos
    }
  },

  methods: {
    // receives a place object via the autocomplete component
    setPlace(place) {
      this.currentPlace = place;
    },
    addTangoSite() {   
      // this method is doing the inital sites charge
      mapsManagerService.getAll().then(response => {         
        response.data.features.forEach(point => {
          if (point.properties.business !== 'event') {
            const site = {			
              id: uuid.v4(),
              description: point.properties.description,
              business: point.properties.business,
              frequency: point.properties.frequency,
              icon: point.properties.frequency,
              day: point.properties.day,
              coordinates: {
                  lat: point.geometry.coordinates[1],
                  lng: point.geometry.coordinates[0]
              }
            };
            tangoSitiosRef.push(site);
          } else {
            const site = {			
              id: uuid.v4(),              
              business: point.properties.business,              
              icon: point.properties.business,
              eventYear: point.properties.eventYear,
              eventName: point.properties.eventName,
              eventInfo: point.properties.eventInfo,
              eventAddress: point.properties.eventAddress,
              eventContact: point.properties.eventContact,
              eventContactWebsite: point.properties.eventContactWebsite,
              eventContactMail: point.properties.eventContactMail,
              coordinates: {
                  lat: point.geometry.coordinates[1],
                  lng: point.geometry.coordinates[0]
              }
            };
            tangoEventosRef.push(site);
          }
        })
      });
    },
    addMarker() {
      if (this.currentPlace) {
        const marker = {
          lat: this.currentPlace.geometry.location.lat(),
          lng: this.currentPlace.geometry.location.lng()
        };
        this.markers.push({ position: marker });
        this.places.push(this.currentPlace);
        this.center = marker;
        this.currentPlace = null;
      }
    },
    geolocate: function() {
      navigator.geolocation.getCurrentPosition(position => {
        this.center = {
          lat: position.coords.latitude,
          lng: position.coords.longitude
        };
      });
    },
    getAll: function() {
      /*mapsManagerService.getAll().then(response => { 
        
        response.data.features.forEach(point => {
          const marker = {
            lat: point.geometry.coordinates[1],
            lng: point.geometry.coordinates[0]
          };
          this.markers.push({
            position: marker,
            icon: this.getIcon(point)
          });  
        });
      });*/
    }
  },
  firebase: {
    sites: tangoSitiosRef,
    events: tangoEventosRef
  }
};
</script>

<style scoped>
</style>
